# Subtitle Reader

## Collaborate on this project.

[Please go here. ](https://github.com/maxe-hsieh/subtitle_reader)

---

## overview

When you use a browser to watch videos, assist NVDA in finding CC subtitles on the page and have NVDA read and display them in real-time with speech and braille.

---

## description

### features

* Support Netflix, Disney+, Youtube, KKTV and other websites.
* Support commonly used browsers.
* Automatically find CC subtitles on the web page.
* Voice and braille feedback.
* Automatic update check
* Quick toggle switch

---

### Operating instructions.

Using a browser, open a supported website and select a video with CC subtitles available. Then move the focus to the range of the video player and you will be able to hear or read the subtitles on a braille display.

To pause subtitle feedback, you can turn off NVDA speech output, turn off subtitles on the player, or press NVDA+y to stop feedback.

---

### NVDA Compatibility

The subtitle reader is trying to support all versions of NVDA, and the oldest version tested is 2019.2.1.

---

### Support Browsers

The following lists the browsers and the latest tested version that the subtitle reader supports:

* Google Chrome (97.0.4692.99 (正式版本) (64 位元))
* Mozilla Firefox (77.0.1（64 位元）)
* Microsoft Edge (97.0.1072.76 (官方組建) (64 位元))
* Brave (1.34.81 Chromium: 97.0.4692.99 (正式版本) (64 位元))

---

### Gestures

The following lists the default gestures and their corresponding functions. All gestures can be changed in the NVDA input gesture settings.

* NVDA+y: Toggle Subtitle Reader

---

### Notes

1. The subtitle reader is only available in the browsers listed above.
2. Focus must be on the video player to hear the subtitles, and usually the current time, volume, and controls for setting the video playback are all part of the video player's range.
3. Please confirm that the video has CC subtitles available, if it does, you can use the browsing mode to find the dynamic subtitle text.
4. If the website updates its playback interface, the subtitle reader will become invalid, please wait for the subtitle reader to be updated, or contact me using the contact information below.

---

## Contact Information.

If you have any questions or suggestions while using it, feel free to contact me from the list below.

* Skype:
[p15937a](https://join.skype.com/invite/VnIdifjym1OR)
* Facebook:
[Profile](https://m.facebook.com/profile.php?id=100002631752665&refid=46&ref=content_filter&__xts__[0]=12.%7B%22browse_result_type%22%3A%22browse_type_user%22%2C%22click_type%22%3A%22result%22%2C%22module_result_position%22%3A0%2C%22module_role%22%3A%22ENTITY_USER%22%2C%22result_id%22%3A100002631752665%2C%22session_id%22%3A%222108b07c-e391-4921-aaa7-474a90634d73%22%2C%22unit_id%22%3A%22mtouch_bem_res%3A30287062e76b81d229366f24878df5b4%22%2C%22unit_id_click_type%22%3A%22graph_search_results_item_in_module_tapped%22%2C%22unit_id_result_id%22%3A100002631752665%7D)
* NVDA 台灣 討論區：
[[分享] 字幕閱讀器 - 討論區  |   NVDA 台灣](https://www.nvda.tw/discussion/ui=2005603400tm=1964947895)

---
